Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3483)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3484)
@@ -4807,5 +5038,7 @@
                                              logc_w_s, logc_ratio_w_s,         &
                                              logc_kbounds_w_s,                 &
-                                             nzt_topo_nestbc_s, 's', 's' )
+                                             nzt_topo_nestbc_s,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 's', 's' )
 
                    CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
@@ -4813,5 +5046,7 @@
                                              logc_w_s, logc_ratio_w_s,         &
                                              logc_kbounds_w_s,                 &
-                                             nzt_topo_nestbc_s, 's', 's' )
+                                             nzt_topo_nestbc_s,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 's', 's' )
 
                 ENDIF
@@ -4823,5 +5058,7 @@
                                              logc_w_s, logc_ratio_w_s,         &
                                              logc_kbounds_w_s,                 &
-                                             nzt_topo_nestbc_s, 's', 's' )
+                                             nzt_topo_nestbc_s,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 's', 's' )
 
                    CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
@@ -4829,5 +5066,7 @@
                                              logc_w_s, logc_ratio_w_s,         &
                                              logc_kbounds_w_s,                 &
-                                             nzt_topo_nestbc_s, 's', 's' )
+                                             nzt_topo_nestbc_s,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 's', 's' )
 
                 ENDIF
@@ -4840,5 +5079,7 @@
                                           logc_w_s, logc_ratio_w_s,            &
                                           logc_kbounds_w_s,                    &
-                                          nzt_topo_nestbc_s, 's', 's' )
+                                          nzt_topo_nestbc_s,                   &
+                                          kcto, iflo, ifuo, jflo, jfuo,        &
+                                          kflo, kfuo, ijkfc_s, 's', 's' )
              ENDIF
 
@@ -4851,5 +5092,7 @@
                                              logc_w_s, logc_ratio_w_s,         &
                                              logc_kbounds_w_s,                 &
-                                             nzt_topo_nestbc_s, 's', 's' )
+                                             nzt_topo_nestbc_s,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 's', 's' )
                 ENDDO
              ENDIF
@@ -4862,28 +5105,36 @@
                                        r1yo, r2yo, r1zo, r2zo,                 &
                                        logc_u_n, logc_ratio_u_n,               &
-                                       logc_kbounds_u_n,                       &
-                                       nzt_topo_nestbc_n, 'n', 'u' )
+                                       logc_kbounds_u_n, nzt_topo_nestbc_n,    &
+                                       kcto, iflu, ifuu, jflo, jfuo, kflo,     &
+                                       kfuo, ijkfc_u, 'n', 'u' )
 
              CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
                                        r1yv, r2yv, r1zo, r2zo,                 &
                                        logc_v_n, logc_ratio_v_n,               &
-                                       logc_kbounds_v_n,                       &
-                                       nzt_topo_nestbc_n, 'n', 'v' )
+                                       logc_kbounds_v_n, nzt_topo_nestbc_n,    &
+                                       kcto, iflo, ifuo, jflv, jfuv, kflo,     &
+                                       kfuo, ijkfc_v, 'n', 'v' )
 
              CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
                                        r1yo, r2yo, r1zw, r2zw,                 &
                                        logc_w_n, logc_ratio_w_n,               &
-                                       logc_kbounds_w_n,                       &
-                                       nzt_topo_nestbc_n, 'n', 'w' )
+                                       logc_kbounds_w_n, nzt_topo_nestbc_n,    &
+                                       kctw, iflo, ifuo, jflo, jfuo, kflw,     &
+                                       kfuw, ijkfc_w, 'n', 'w' )
 
              IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   & 
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-                CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo,              &
-                                          logc_w_n, logc_ratio_w_n,            &
-                                          logc_kbounds_w_n,                    &
-                                          nzt_topo_nestbc_n, 'n', 'e' )
-
+!                CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                                          r1yo, r2yo, r1zo, r2zo,              &
+!                                          logc_w_n, logc_ratio_w_n,            &
+!                                          logc_kbounds_w_n, nzt_topo_nestbc_n, &
+!                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+!                                          kfuo, ijkfc_s, 'n', 'e' )
+!
+!--             Interpolation of e is replaced by the Neumann condition. 
+                DO jbgp = ny+1, ny+nbgp
+                   e(nzb:nzt,jbgp,nxl:nxr) = e(nzb:nzt,ny,nxl:nxr)
+                ENDDO
              ENDIF
 
@@ -4892,6 +5143,7 @@
                                           r2xo, r1yo, r2yo, r1zo, r2zo,        &
                                           logc_w_n, logc_ratio_w_n,            &
-                                          logc_kbounds_w_n,                    &
-                                          nzt_topo_nestbc_n, 'n', 's' )
+                                          logc_kbounds_w_n, nzt_topo_nestbc_n, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'n', 's' )
 
              ENDIF
@@ -4901,6 +5153,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_n, logc_ratio_w_n,            &
-                                          logc_kbounds_w_n,                    &
-                                          nzt_topo_nestbc_n, 'n', 's' )
+                                          logc_kbounds_w_n, nzt_topo_nestbc_n, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'n', 's' )
              ENDIF
 
@@ -4909,6 +5162,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_n, logc_ratio_w_n,            &
-                                          logc_kbounds_w_n,                    &
-                                          nzt_topo_nestbc_n, 'n', 's' )
+                                          logc_kbounds_w_n, nzt_topo_nestbc_n, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'n', 's' )
 
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
@@ -4918,5 +5172,7 @@
                                              logc_w_n, logc_ratio_w_n,         &
                                              logc_kbounds_w_n,                 &
-                                             nzt_topo_nestbc_n, 'n', 's' )
+                                             nzt_topo_nestbc_n,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'n', 's' )
 
                    CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
@@ -4924,5 +5180,7 @@
                                              logc_u_n, logc_ratio_u_n,         &
                                              logc_kbounds_w_n,                 &
-                                             nzt_topo_nestbc_n, 'n', 's' )
+                                             nzt_topo_nestbc_n,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'n', 's' )
 
                 ENDIF
@@ -4934,5 +5192,7 @@
                                              logc_w_n, logc_ratio_w_n,         &
                                              logc_kbounds_w_n,                 &
-                                             nzt_topo_nestbc_n, 'n', 's' )
+                                             nzt_topo_nestbc_n,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'n', 's' )
 
                    CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
@@ -4940,5 +5200,7 @@
                                              logc_w_n, logc_ratio_w_n,         &
                                              logc_kbounds_w_n,                 &
-                                             nzt_topo_nestbc_n, 'n', 's' )
+                                             nzt_topo_nestbc_n,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'n', 's' )
 
                 ENDIF
@@ -4951,5 +5213,7 @@
                                           logc_w_n, logc_ratio_w_n,            &
                                           logc_kbounds_w_n,                    &
-                                          nzt_topo_nestbc_n, 'n', 's' )
+                                          nzt_topo_nestbc_n,                   &
+                                          kcto, iflo, ifuo, jflo, jfuo,        &
+                                          kflo, kfuo, ijkfc_s, 'n', 's' )
              ENDIF
 
@@ -4962,5 +5226,7 @@
                                              logc_w_n, logc_ratio_w_n,         &
                                              logc_kbounds_w_n,                 &
-                                             nzt_topo_nestbc_n, 'n', 's' )
+                                             nzt_topo_nestbc_n,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'n', 's' )
                 ENDDO
              ENDIF
@@ -4971,25 +5237,35 @@
 !--    All PEs are top-border PEs
        CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,      &
-                                r2yo, r1zo, r2zo, 'u' )
+                                r2yo, r1zo, r2zo, kcto, iflu, ifuu,            &
+                                jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
        CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,      &
-                                r2yv, r1zo, r2zo, 'v' )
+                                r2yv, r1zo, r2zo, kcto, iflo, ifuo,            &
+                                jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
        CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
-                                r2yo, r1zw, r2zw, 'w' )
+                                r2yo, r1zw, r2zw, kctw, iflo, ifuo,            &
+                                jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
 
        IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
             (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
                .NOT. constant_diffusion ) )  THEN
-          CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
-                                   r2yo, r1zo, r2zo, 'e' )
+!          CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
+!                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
+!                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
+!
+!--       Interpolation of e is replaced by the Neumann condition. 
+          e(nzt+1,nys:nyn,nxl:nxr) = e(nzt,nys:nyn,nxl:nxr)
+
        ENDIF
 
        IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
           CALL pmci_interp_tril_t( diss, dissc, ico, jco, kco, r1xo, r2xo,     &
-                                   r1yo, r2yo, r1zo, r2zo, 's' )
+                                   r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
+                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
        ENDIF
 
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,   &
-                                   r2yo, r1zo, r2zo, 's' )
+          CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo,         &
+                                   r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
+                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
        ENDIF
 
@@ -4997,13 +5273,16 @@
 
           CALL pmci_interp_tril_t( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo,    &
-                                   r2yo, r1zo, r2zo, 's' )
+                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
+                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
           IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
              CALL pmci_interp_tril_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, 's' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
              CALL pmci_interp_tril_t( nc, ncc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, 's' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
           ENDIF
@@ -5013,8 +5292,10 @@
 
              CALL pmci_interp_tril_t( qr, qrc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, 's' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
              CALL pmci_interp_tril_t( nr, nrc, ico, jco, kco, r1xo, r2xo, r1yo,&
-                                      r2yo, r1zo, r2zo, 's' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
           ENDIF
@@ -5024,5 +5305,6 @@
        IF ( passive_scalar )  THEN
           CALL pmci_interp_tril_t( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,     &
-                                   r2yo, r1zo, r2zo, 's' )
+                                   r2yo, r1zo, r2zo, kcto, iflo, ifuo,         &
+                                   jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
        ENDIF
 
@@ -5033,5 +5315,6 @@
                                       ico, jco, kco, r1xo, r2xo,               &
                                       r1yo, r2yo, r1zo, r2zo,                  &
-                                      's' )
+                                      kcto, iflo, ifuo, jflo, jfuo,            &
+                                      kflo, kfuo, ijkfc_s, 's' )
           ENDDO
        ENDIF
@@ -5050,9 +5333,7 @@
       INTEGER(iwp) ::  n          !< running index for number of chemical species
 
-
-
-      CALL pmci_anterp_tophat( u,  uc,  kctu, iflu, ifuu, jflo, jfuo, kflo,    &
+      CALL pmci_anterp_tophat( u,  uc,  kcto, iflu, ifuu, jflo, jfuo, kflo,    &
                                kfuo, ijkfc_u, 'u' )
-      CALL pmci_anterp_tophat( v,  vc,  kctu, iflo, ifuo, jflv, jfuv, kflo,    &
+      CALL pmci_anterp_tophat( v,  vc,  kcto, iflo, ifuo, jflv, jfuv, kflo,    &
                                kfuo, ijkfc_v, 'v' )
       CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,    &
@@ -5062,10 +5343,10 @@
 !--   RANS mode.
       IF ( rans_mode_parent  .AND.  rans_mode )  THEN
-         CALL pmci_anterp_tophat( e, ec, kctu, iflo, ifuo, jflo, jfuo, kflo,   &
+         CALL pmci_anterp_tophat( e, ec, kcto, iflo, ifuo, jflo, jfuo, kflo,   &
                                   kfuo, ijkfc_s, 'e' )
 !
 !--      Anterpolation of dissipation rate only if TKE-e closure is applied.
          IF ( rans_tke_e )  THEN
-            CALL pmci_anterp_tophat( diss, dissc, kctu, iflo, ifuo, jflo, jfuo,&
+            CALL pmci_anterp_tophat( diss, dissc, kcto, iflo, ifuo, jflo, jfuo,&
                                      kflo, kfuo, ijkfc_s, 'diss' )
          ENDIF
@@ -5074,5 +5355,5 @@
 
       IF ( .NOT. neutral )  THEN
-         CALL pmci_anterp_tophat( pt, ptc, kctu, iflo, ifuo, jflo, jfuo, kflo, &
+         CALL pmci_anterp_tophat( pt, ptc, kcto, iflo, ifuo, jflo, jfuo, kflo, &
                                   kfuo, ijkfc_s, 'pt' )
       ENDIF
@@ -5080,13 +5361,13 @@
       IF ( humidity )  THEN
 
-         CALL pmci_anterp_tophat( q, q_c, kctu, iflo, ifuo, jflo, jfuo, kflo,  &
+         CALL pmci_anterp_tophat( q, q_c, kcto, iflo, ifuo, jflo, jfuo, kflo,  &
                                   kfuo, ijkfc_s, 'q' )
 
          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
-            CALL pmci_anterp_tophat( qc, qcc, kctu, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( qc, qcc, kcto, iflo, ifuo, jflo, jfuo,    &
                                      kflo, kfuo, ijkfc_s, 'qc' )
 
-            CALL pmci_anterp_tophat( nc, ncc, kctu, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( nc, ncc, kcto, iflo, ifuo, jflo, jfuo,    &
                                      kflo, kfuo, ijkfc_s, 'nc' )
 
@@ -5095,8 +5376,8 @@
          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
-            CALL pmci_anterp_tophat( qr, qrc, kctu, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( qr, qrc, kcto, iflo, ifuo, jflo, jfuo,    &
                                      kflo, kfuo, ijkfc_s, 'qr' )
 
-            CALL pmci_anterp_tophat( nr, nrc, kctu, iflo, ifuo, jflo, jfuo,    &
+            CALL pmci_anterp_tophat( nr, nrc, kcto, iflo, ifuo, jflo, jfuo,    &
                                      kflo, kfuo, ijkfc_s, 'nr' )
 
@@ -5106,5 +5387,5 @@
 
       IF ( passive_scalar )  THEN
-         CALL pmci_anterp_tophat( s, sc, kctu, iflo, ifuo, jflo, jfuo, kflo,   &
+         CALL pmci_anterp_tophat( s, sc, kcto, iflo, ifuo, jflo, jfuo, kflo,   &
                                   kfuo, ijkfc_s, 's' )
       ENDIF
@@ -5114,5 +5395,5 @@
             CALL pmci_anterp_tophat( chem_species(n)%conc,                     &
                                      chem_spec_c(:,:,:,n),                     &
-                                     kctu, iflo, ifuo, jflo, jfuo, kflo,       &
+                                     kcto, iflo, ifuo, jflo, jfuo, kflo,       &
                                      kfuo, ijkfc_s, 's' )
          ENDDO
@@ -5125,5 +5406,7 @@
    SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
                                    r2z, logc, logc_ratio, logc_kbounds,        &
-                                   nzt_topo_nestbc, edge, var )
+                                   nzt_topo_nestbc,                            &
+                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
+                                   edge, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
@@ -5132,6 +5415,4 @@
 
       IMPLICIT NONE
-
-      INTEGER(iwp) ::  nzt_topo_nestbc   !<
 
       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
@@ -5152,6 +5433,21 @@
       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !<
       INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                &
-                                          INTENT(IN)           ::  logc   !<
-      INTEGER(iwp), DIMENSION(1:2,nys:nyn), INTENT(IN)         ::  logc_kbounds !<
+                                          INTENT(IN)           :: logc   !<
+      INTEGER(iwp), DIMENSION(1:2,nys:nyn), INTENT(IN)         :: logc_kbounds !<
+
+      INTEGER(iwp) :: kct
+      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+
+      INTEGER(iwp) ::  nzt_topo_nestbc   !<
 
       CHARACTER(LEN=1), INTENT(IN) ::  edge   !<
@@ -5159,10 +5455,14 @@
 
       INTEGER(iwp) ::  i        !<
+      INTEGER(iwp) ::  ia       !<
       INTEGER(iwp) ::  ib       !<
       INTEGER(iwp) ::  ibgp     !<
+      INTEGER(iwp) ::  ijk      !<
+      INTEGER(iwp) ::  iw       !<
       INTEGER(iwp) ::  j        !<
       INTEGER(iwp) ::  jco      !<
       INTEGER(iwp) ::  jcorr    !<
       INTEGER(iwp) ::  jinc     !<
+      INTEGER(iwp) ::  jw       !<
       INTEGER(iwp) ::  j1       !<
       INTEGER(iwp) ::  k        !<
@@ -5174,5 +5474,9 @@
       INTEGER(iwp) ::  m        !<
       INTEGER(iwp) ::  n        !<
-      
+      INTEGER(iwp) ::  kbc      !<
+      INTEGER(iwp) ::  var_flag !<      
+
+      REAL(wp) ::  cellsum     !<
+      REAL(wP) ::  cellsumd    !<
       REAL(wp) ::  fkj         !<
       REAL(wp) ::  fkjp        !<
@@ -5181,5 +5485,7 @@
       REAL(wp) ::  fk          !<
       REAL(wp) ::  fkp         !<
-      
+      REAL(wp) ::  rcorr       !<
+      REAL(wp) ::  rcorr_ijk   !<
+ 
 ! 
 !--   Check which edge is to be handled
@@ -5198,11 +5504,21 @@
          ib = nxr + 2
       ENDIF
-      
+
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2 
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
+      ENDIF
+   
       DO  j = nys, nyn+1
 !
 !--      Determine vertical index of topography top at grid point (j,i)
-         k_wall = get_topography_top_index_ji( j, i, TRIM( var ) )
-
-         DO  k = k_wall, nzt+1
+!AH         k_wall = get_topography_top_index_ji( j, i, TRIM( var ) )
+
+         DO  k = nzb, nzt+1 !k_wall, nzt+1
             l = ic(i)
             m = jc(j)
@@ -5235,5 +5551,5 @@
                DO  kcorr = 0, ncorr - 1
                   kco = k + kcorr
-                  f(kco,j,i) = logc_ratio(1,kcorr,k,j) * f(k1,j,i)
+!AH                  f(kco,j,i) = logc_ratio(1,kcorr,k,j) * f(k1,j,i)
                ENDDO
             ENDIF
@@ -5261,5 +5577,5 @@
                         jco = j + jinc * jcorr
                         IF ( jco >= nys .AND. jco <= nyn )  THEN
-                           f(k,jco,i) = logc_ratio(2,jcorr,k,j) * f(k,j1,i)
+!AH                           f(k,jco,i) = logc_ratio(2,jcorr,k,j) * f(k,j1,i)
                         ENDIF
                      ENDDO
@@ -5282,8 +5598,8 @@
                         DO  kcorr = 0, ncorr-1
                            kco = k + kcorr
-                           f(kco,jco,i) = 0.5_wp * ( logc_ratio(1,kcorr,k,j) * &
-                                                     f(k1,j,i)                 &
-                                                   + logc_ratio(2,jcorr,k,j) * &
-                                                     f(k,j1,i) )
+!AH                           f(kco,jco,i) = 0.5_wp * ( logc_ratio(1,kcorr,k,j) * &
+!AH                                                     f(k1,j,i)                 &
+!AH                                                   + logc_ratio(2,jcorr,k,j) * &
+!AH                                                     f(k,j1,i) )
                         ENDDO
                      ENDIF
@@ -5295,31 +5611,71 @@
       ENDIF  ! ( topography /= 'flat' )
 !
-!--   Rescale if f is the TKE.
-      IF ( var == 'e')  THEN
-         IF ( edge == 'l' )  THEN
-            DO  j = nys, nyn + 1
-!
-!--            Determine vertical index of topography top at grid point (j,i)
-               k_wall = get_topography_top_index_ji( j, i, 's' )
-
-               DO  k = k_wall, nzt + 1
-                  f(k,j,i) = tkefactor_l(k,j) * f(k,j,i)
+!--   Apply the reversibility correction to the boundary-normal velocity-
+!--   component u and the scalars. It must not be applied to the boundary-
+!--   tangential velocity components v and w because their 2-D anterpolation
+!--   cells do not cover all the child-grid nodes on the boundary.
+      IF ( .NOT. ( ( var == 'v' ) .OR. ( var == 'w' ) ) )  THEN
+         l = ic(i)
+         DO  m = jcs, jcn
+            DO  n = 0, kct+1
+               ijk = 1
+               cellsum   = 0.0_wp
+               cellsumd  = 0.0_wp
+!
+!--            Note that the index name i must not be used here as a loop 
+!--            index name since i is the constant boundary index, hence 
+!--            the name ia. 
+               DO  ia = ifl(l), ifu(l)   
+                  DO  j = jfl(m), jfu(m)
+                     DO  k = kfl(n), kfu(n)
+                        cellsum = cellsum + MERGE( f(k,j,ia), 0.0_wp,           &
+                             BTEST( wall_flags_0(k,j,ia), var_flag ) )
+                        celltmpd(ijk) = ABS( fc(n,m,l) - f(k,j,ia) )
+                        cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
+                             0.0_wp, BTEST( wall_flags_0(k,j,ia), var_flag ) )
+                        ijk = ijk + 1
+                     ENDDO
+                  ENDDO
                ENDDO
-            ENDDO
-         ELSEIF ( edge == 'r' )  THEN           
-            DO  j = nys, nyn+1
-!
-!--            Determine vertical index of topography top at grid point (j,i)
-               k_wall = get_topography_top_index_ji( j, i, 's' )
-
-               DO  k = k_wall, nzt+1
-                  f(k,j,i) = tkefactor_r(k,j) * f(k,j,i)
+
+               IF ( ijkfc(n,m,l) /= 0 )  THEN
+                  cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+                  rcorr     = fc(n,m,l) - cellsum
+                  cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
+               ELSE
+                  cellsum   = 0.0_wp                  
+                  rcorr     = 0.0_wp
+                  cellsumd  = 1.0_wp
+                  celltmpd  = 1.0_wp
+               ENDIF
+! 
+!--            Distribute the correction term to the child nodes according to 
+!--            their relative difference to the parent value such that the
+!--            node with the largest difference gets the largest share of the 
+!--            correction. The distribution is skipped if rcorr is negligibly 
+!--            small in order to avoid division by zero. 
+               IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
+                  cellsumd  = 1.0_wp
+                  celltmpd  = 1.0_wp
+               ENDIF
+
+               ijk = 1
+               DO  ia = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfu(m)
+                     DO  k = kfl(n), kfu(n)
+                        rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+                        f(k,j,ia) = f(k,j,ia) + rcorr_ijk
+                        ijk = ijk + 1
+                     ENDDO
+                  ENDDO
                ENDDO
-            ENDDO
-         ENDIF
-      ENDIF
+               
+            ENDDO  ! n
+         ENDDO  ! m
+         
+      ENDIF  ! var not v or w 
 !
 !--   Store the boundary values also into the other redundant ghost node layers.
-!--   Please note, in case of only one ghost node layer, e.g. for the PW 
+!--   Note that in case of only one ghost node layer, e.g. for the PW 
 !--   scheme, the following loops will not be entered.
       IF ( edge == 'l' )  THEN
@@ -5339,5 +5695,7 @@
    SUBROUTINE pmci_interp_tril_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
                                    r2z, logc, logc_ratio, logc_kbounds,        &
-                                   nzt_topo_nestbc, edge, var )
+                                   nzt_topo_nestbc,                            &
+                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
+                                   edge, var )
 
 !
@@ -5347,6 +5705,4 @@
 
       IMPLICIT NONE
-
-      INTEGER(iwp) ::  nzt_topo_nestbc   !<
 
       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
